Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# deTArray< T > Class Template Reference

templated resizable linear array storage class More...

`#include <deArray.hpp>`

Inheritance diagram for deTArray< T >:

[legend]
Collaboration diagram for deTArray< T >:

[legend]
List of all members.

## Public Types
typedef T * | iterator
## Public Member Functions
| deTArray (void)
| deTArray (const deTArray &RHS)
| deTArray (size_t InitialSize)
| deTArray (size_t InitialSize, const T &Value)
| ~deTArray ()
deTArray< T > & | operator= (const deTArray< T > &ref)
T & | operator[] (size_t ArrayItemIndex)
const T & | operator[] (size_t ArrayItemIndex) const
iterator | get_iterator (size_t ArrayItemIndex) const
deBoolean | PushBack (const T &element)
deBoolean | InsertArrayQuick (const T *Array, size_t StartIndex, size_t NumElements)
iterator | IncrementSize ()
iterator | IncrementSizeQuick (deBoolean ZeroMem=(DE_FALSE))
deBoolean | Reserve (size_t NewSize, deBoolean PrimitiveType=(DE_FALSE))
deBoolean | Resize (size_t NewSize)
deBoolean | ResizeQuick (size_t NewSize, deBoolean ZeroMem=(DE_FALSE))
deBoolean | RemoveElementAt (size_t index)
T * | GetCArray () const
size_t | Length () const
size_t | size () const
size_t | capacity () const
iterator | begin () const
iterator | end () const
deBoolean | resize (size_t NewSize)
iterator | push_back (const T &element)
iterator | erase (iterator &it)
## Static Public Member Functions
u32 | SmallestLargerPow2 (u32 x)
## Private Member Functions
iterator | make_iterator (size_t index) const
size_t | iterator_index (const iterator &it)
## Private Attributes
size_t | m_Length
size_t | m_Capacity
T * | m_Items

## Detailed Description

### template<class T>
class deTArray< T >

templated resizable linear array storage class

## Member Typedef Documentation

template<class T>
typedef T* deTArray< T >::iterator

## Constructor & Destructor Documentation

template<class T>
deTArray< T >::deTArray | ( | void |  | ) | `[inline]`

template<class T>
deTArray< T >::deTArray | ( | const deTArray< T > & | RHS | ) | `[inline]`

template<class T>
deTArray< T >::deTArray | ( | size_t | InitialSize | ) | `[inline]`

template<class T>
deTArray< T >::deTArray | ( | size_t | InitialSize,
|  | const T & | Value
| ) | `[inline]`

template<class T>
deTArray< T >::~deTArray | ( |  | ) | `[inline]`

## Member Function Documentation

template<class T>
iterator deTArray< T >::begin | ( |  | ) | const`[inline]`

template<class T>
size_t deTArray< T >::capacity | ( |  | ) | const`[inline]`

template<class T>
iterator deTArray< T >::end | ( |  | ) | const`[inline]`

template<class T>
iterator deTArray< T >::erase | ( | iterator & | it | ) | `[inline]`

template<class T>
iterator deTArray< T >::get_iterator | ( | size_t | ArrayItemIndex | ) | const`[inline]`

template<class T>
T* deTArray< T >::GetCArray | ( |  | ) | const`[inline]`

template<class T>
iterator deTArray< T >::IncrementSize | ( |  | ) | `[inline]`

template<class T>
iterator deTArray< T >::IncrementSizeQuick | ( | deBoolean | ZeroMem = (DE_FALSE) | ) | `[inline]`

template<class T>
deBoolean deTArray< T >::InsertArrayQuick | ( | const T * | Array,
|  | size_t | StartIndex,
|  | size_t | NumElements
| ) | `[inline]`

template<class T>
size_t deTArray< T >::iterator_index | ( | const iterator & | it | ) | `[inline, private]`

template<class T>
size_t deTArray< T >::Length | ( |  | ) | const`[inline]`

template<class T>
iterator deTArray< T >::make_iterator | ( | size_t | index | ) | const`[inline, private]`

template<class T>
deTArray<T>& deTArray< T >::operator= | ( | const deTArray< T > & | ref | ) | `[inline]`

template<class T>
const T& deTArray< T >::operator[] | ( | size_t | ArrayItemIndex | ) | const`[inline]`

template<class T>
T& deTArray< T >::operator[] | ( | size_t | ArrayItemIndex | ) | `[inline]`

template<class T>
iterator deTArray< T >::push_back | ( | const T & | element | ) | `[inline]`

template<class T>
deBoolean deTArray< T >::PushBack | ( | const T & | element | ) | `[inline]`

template<class T>
deBoolean deTArray< T >::RemoveElementAt | ( | size_t | index | ) | `[inline]`

template<class T>
deBoolean deTArray< T >::Reserve | ( | size_t | NewSize,
|  | deBoolean | PrimitiveType = (DE_FALSE)
| ) | `[inline]`

template<class T>
deBoolean deTArray< T >::resize | ( | size_t | NewSize | ) | `[inline]`

template<class T>
deBoolean deTArray< T >::Resize | ( | size_t | NewSize | ) | `[inline]`

template<class T>
deBoolean deTArray< T >::ResizeQuick | ( | size_t | NewSize,
|  | deBoolean | ZeroMem = (DE_FALSE)
| ) | `[inline]`

template<class T>
size_t deTArray< T >::size | ( |  | ) | const`[inline]`

template<class T>
u32 deTArray< T >::SmallestLargerPow2 | ( | u32 | x | ) | `[inline, static]`

## Member Data Documentation

template<class T>
size_t deTArray< T >::m_Capacity`[private]`

template<class T>
T* deTArray< T >::m_Items`[private]`

template<class T>
size_t deTArray< T >::m_Length`[private]`

The documentation for this class was generated from the following file:

- deArray.hpp